package org.anarres.jperf;

import java.util.AbstractMap;
import java.util.AbstractSet;
import java.util.Iterator;
import java.util.Set;
import java.util.Map;
import java.util.NoSuchElementException;

public class PerfectStringMap<V> extends PerfectMap<String,V> {

	private int[]	kvals;
	private char	min;
	private byte[]	keys;

	public PerfectStringMap(Map.Entry[] table,
					int[] kvals, char min,
					byte[] keys) {
		super(table);
		this.kvals = kvals;
		this.min = min;
		this.keys = keys;
	}

	/* This is a well known algorithm. */
	protected int hash(String k) {
		/* Could just use an ArrayOutOfBoundsException trap here. */
		int	klen = k.length();
		int	out = klen;
		for (byte b : keys) {
			int		c;
			if (b >= 0) {
				if (b >= klen)
					continue;
				c = k.charAt(b) - min;
			}
			else {
				int	kidx = klen + b;	// b is negative
				if (kidx < 0)
					continue;
				if (kidx >= klen)
					continue;
				c = k.charAt(kidx) - min;
			}
			if (c < 0)
				return -1;
			if (c >= kvals.length)
				return -2;
			out += kvals[c];
		}
		return out;
	}

}
