package org.anarres.jperf;

import java.util.*;

import junit.framework.Test;
import junit.framework.TestCase;

public class PerfectObjectMapTestCase extends TestCase implements Test {

	public void testPerfectObjectMap() throws Exception {
		PerfectObjectMapGenerator<Class,Long>	gen =
				new PerfectObjectMapGenerator<Class,Long>();
		gen.add(Long.class, 1L);
		gen.add(Integer.class, 2L);
		gen.add(String.class, 3L);
		Map<Class,Long>	map = gen.toMap();
		assertEquals(Long.valueOf(1), map.get(Long.class));
		assertEquals(Long.valueOf(2), map.get(Integer.class));
		assertEquals(Long.valueOf(3), map.get(String.class));
		assertEquals(null, map.get(Short.class));
		assertEquals(null, map.get(Float.class));
		assertEquals(null, map.get(Double.class));
		assertEquals(null, map.get(Character.class));
		assertTrue(((PerfectMap)map).getTableSize() < 10);
		assertEquals(3, map.size());
		assertEquals(3, map.entrySet().size());
		assertTrue(!map.isEmpty());
		assertTrue(!map.entrySet().isEmpty());
		assertTrue(map.containsKey(Long.class));
		assertTrue(!map.containsKey(Short.class));
		assertTrue(map.entrySet().iterator().hasNext());
		assertNotNull(map.entrySet().iterator().next());
	}

	public void testEmptyObjectMap() throws Exception {
		PerfectObjectMapGenerator<Class,String>	gen =
				new PerfectObjectMapGenerator<Class,String>();
		Map<Class,String>	map = gen.toMap();
		assertTrue(map.isEmpty());
		assertEquals(0, map.size());
		assertEquals(0, ((PerfectMap)map).getTableSize());
		assertTrue(!map.entrySet().iterator().hasNext());
	}

}
